Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.0.CR4
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.impl.score.buildin.bendable
Class BendableScoreDefinition

    java.lang.Object
      org.optaplanner.core.impl.score.definition.AbstractScoreDefinition<BendableScore>
          org.optaplanner.core.impl.score.buildin.bendable.BendableScoreDefinition

All Implemented Interfaces:
  Serializable, ScoreDefinition<BendableScore>

    public class BendableScoreDefinition

extends AbstractScoreDefinition<BendableScore>

See Also:
  Serialized Form

Constructor Summary
`BendableScoreDefinition(int hardLevelCount, int softLevelCount)`

Method Summary
`ScoreHolder` | `buildScoreHolder(boolean constraintMatchEnabled)`
`double` | `calculateTimeGradient(BendableScore startScore, BendableScore endScore, BendableScore score)` See explanation in `Termination.calculateSolverTimeGradient(DefaultSolverScope)`.
`BendableScore` | `createScore(int... scores)`
`int` | `getHardLevelCount()`
`BendableScore` | `getPerfectMaximumScore()` The perfect maximum `Score` is the `Score` of which there is no better in any problem instance.
`BendableScore` | `getPerfectMinimumScore()` The perfect minimum `Score` is the `Score` of which there is no worse in any problem instance.
`double` | `getRecursiveTimeGradientWeight()`
`Class<BendableScore>` | `getScoreClass()` Returns the `Class` of the actual `Score` implementation
`int` | `getSoftLevelCount()`
`Score` | `parseScore(String scoreString)` Parses the `String` and returns a `Score`.
`void` | `setPerfectMaximumScore(BendableScore perfectMaximumScore)`
`void` | `setPerfectMinimumScore(BendableScore perfectMinimumScore)`
`void` | `setRecursiveTimeGradientWeight(double recursiveTimeGradientWeight)` It's recommended to use a number which can be exactly represented as a double, such as 0.5, 0.25, 0.75, 0.125, ... but not 0.1, 0.2, ...

Methods inherited from class org.optaplanner.core.impl.score.definition.AbstractScoreDefinition
`formatScore`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BendableScoreDefinition

    public BendableScoreDefinition(int hardLevelCount,
                                   int softLevelCount)

Method Detail

### getHardLevelCount

    public int getHardLevelCount()

### getSoftLevelCount

    public int getSoftLevelCount()

### getRecursiveTimeGradientWeight

    public double getRecursiveTimeGradientWeight()

### setRecursiveTimeGradientWeight

    public void setRecursiveTimeGradientWeight(double recursiveTimeGradientWeight)

  It's recommended to use a number which can be exactly represented as a double, such as 0.5, 0.25, 0.75, 0.125, ... but not 0.1, 0.2, ...

  Parameters:
    `recursiveTimeGradientWeight` - 0.0 <= recursiveTimeGradientWeight <= 1.0

### getPerfectMaximumScore

    public BendableScore getPerfectMaximumScore()

  Description copied from interface: `ScoreDefinition`
  The perfect maximum `Score` is the `Score` of which there is no better in any problem instance. This doesn't mean that the current problem instance, or any problem instance for that matter, could ever attain that `Score`. For example, most cases have a perfect maximum `Score` of zero, as most use cases only have negative constraints.

  Specified by:
    `getPerfectMaximumScore` in interface `ScoreDefinition<BendableScore>`
  Overrides:
    `getPerfectMaximumScore` in class `AbstractScoreDefinition<BendableScore>`
  Returns:
    null if not supported

### setPerfectMaximumScore

    public void setPerfectMaximumScore(BendableScore perfectMaximumScore)

### getPerfectMinimumScore

    public BendableScore getPerfectMinimumScore()

  Description copied from interface: `ScoreDefinition`
  The perfect minimum `Score` is the `Score` of which there is no worse in any problem instance. This doesn't mean that the current problem instance, or any problem instance for that matter, could ever attain such a bad `Score`. For example, most cases have a perfect minimum `Score` of negative infinity.

  Specified by:
    `getPerfectMinimumScore` in interface `ScoreDefinition<BendableScore>`
  Overrides:
    `getPerfectMinimumScore` in class `AbstractScoreDefinition<BendableScore>`
  Returns:
    null if not supported

### setPerfectMinimumScore

    public void setPerfectMinimumScore(BendableScore perfectMinimumScore)

### getScoreClass

    public Class<BendableScore> getScoreClass()

  Description copied from interface: `ScoreDefinition`
  Returns the `Class` of the actual `Score` implementation

  Returns:
    never null

### parseScore

    public Score parseScore(String scoreString)

  Description copied from interface: `ScoreDefinition`
  Parses the `String` and returns a `Score`.

  Parameters:
    `scoreString` - never null
  Returns:
    never null
  See Also:
    `ScoreDefinition.formatScore(Score)`

### createScore

    public BendableScore createScore(int... scores)

### calculateTimeGradient

    public double calculateTimeGradient(BendableScore startScore,
                                        BendableScore endScore,
                                        BendableScore score)

  Description copied from interface: `ScoreDefinition`
  See explanation in `Termination.calculateSolverTimeGradient(DefaultSolverScope)`.

  Parameters:
    `startScore` - never null
    `endScore` - never null
    `score` - never null
  Returns:
    between 0.0 and 1.0

### buildScoreHolder

    public ScoreHolder buildScoreHolder(boolean constraintMatchEnabled)

  Parameters:
    `constraintMatchEnabled` - true if `ScoreHolder.isConstraintMatchEnabled()` should be true
  Returns:
    never null

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.0.CR4
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 JBoss by Red Hat. All Rights Reserved.